#include "MTimer.h"
#include "LPC17xx.h"
#include "MTimer.h"
#include "vibro.h"
#include "QEI.h"
#include "Global.h"
#include "SPI.h"
#include "InputOutput.h"

unsigned int CountV64=0;
unsigned int CountV31=0;
unsigned int CountV255=0;
unsigned int CountV511=0;
unsigned int f,MODCount=0;
int loop=0;
int t;
/////////////////////////////////////////////////////
/////////////////////EVENT///////////////////////////
/////////////////////////////////////////////////////
/////////////////////////////////////////////////////
///////////////////// 1250Hz ///////////////////////////
/////////////////////////////////////////////////////
void Event_1250Hz(void)// событие раз в 1,25 КГц
{
	if(Event1250Hz)
	{
		Gyro.EvenRate7=1;
	
		Event1250Hz--;

	}
}




void JumpMod(void)
{
	static int JumpFlag=0;
	switch(JumpFlag) {
	    case 0:
	    	Spi.DAC_B-=Gyro.JumpDelta;
		    JumpFlag=1;
	    break;
	    case 1:
	        Spi.DAC_B+=Gyro.JumpDelta;
		  	JumpFlag=0;
	    break;
	    }
	
}


/////////////////////////////////////////////////////
///////////////////// 1Hz ///////////////////////////
/////////////////////////////////////////////////////

void Event_1Hz(void)// событие раз в 1 Гц
{ 
	static int tempdac=0,tempdac1,JumpTimer=0;
    if (Event1Hz)	
    {
     

     
     if(Gyro.RgConA&0x4) JumpTimer=0;
     else
     	{   
     	/*sprintf((Time),"%d %d\r\n",Gyro.RgConA,JumpTimer);
        WriteCon(Time);*/
     	 JumpTimer++;
    	 if(JumpTimer>(Gyro.TimeToJump-1))
     		{
     		Gyro.PLCDelay	= GyroP.Str.PLCDelay; 
     		JumpMod();
     		JumpTimer=0;
    	 	}
     	}
     
     

      Discharg();
      BackLight();
      Gyro.Rate1_Event = 1; 
      Event1Hz--;
      Time1Hz++; 
     sprintf((Time),"%d \r\n",GyroP.Str.GLD_Serial );
     WriteCon(Time);
    }
}

/////////////////////////////////////////////////////
///////////////////// 1kHz //////////////////////////
/////////////////////////////////////////////////////
void Event_1KHz(void)// событие раз в 1 кГц
{     if (Event1K) 
    {
       if(Gyro.PLCDelay) Gyro.PLCDelay--;
        Event1K --;

        Time1K++;//первый ++ работает каждые 125 (event100kHz)второй был в 100 кГц
        if (Time1K > 1000) 
        {
            Time1K -=1000;
            Event1Hz ++;
        }
        
    }
}

void Event_5KHz(void)// событие раз в 5 кГц
{
	int temp=0;
    if (Event5K) 
    {   
        Gyro.EvenRate5K++;
        Event5K --;
    }
}
void Event_500Hz(void)// событие раз в 500 Гц
{
	if(Event500Hz)
	{   
		if(Gyro.Debag2)
		{
		 	sprintf((Time),"%d   %d   %d\r\n", (0xffff-Spi.DAC_A),  ((Spi.DAC_B-0x7fff)&0xffff), BuffADC_128Point[CountV64]);
     		WriteCon(Time);  
     
     	}
	 Event500Hz--;
	 Gyro.Event_500Hz=1;// Event 500Гц  выдачи данных для постройки графика управления вибро
	}
}
void Event_250Hz(void)
{
	if(Event250Hz)
	{        
      
    // Gyro.CuruAngle=0;
	  Event250Hz--;
	  MODCount++;
	  }
}
/////////////////////////////////////////////////////
///////////////////// 100kHz //////////////////////////
/////////////////////////////////////////////////////
void Event_100KHz(void)// событие раз в 100 кГц
{
        
    if (Event100K)	{
       
        Event100K --;
      
        if (OutBufCon1Count)OutBufCon1Count--;  // обратный отсчет для управления ногой и формирование задержки на выдачу
       
         PinCheng();	// чтение регистра состояния выводов(вибро, полсветка, поджиг, LED) и управление выводами.
    }
}
/////////////////////////////////////////////////////
//////////////////vibro EVENT////////////////////////
/////////////////////////////////////////////////////
void Event_Vibro(void)// событие от вибр
{
    if (EventVibro)	{
        EventVibro --;
    }
}
/////////////////////////////////////////////////////
/////////////////////////////////////////////////////
/////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////TIMER1////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
/////////////////////инициализация таймера 1 /////////////////////////
//////////////////////////////////////////////////////////////////////

unsigned int Init_TIM1 (unsigned int TimerInterval )
{
   // LPC_SC->PCLKSEL0 |= (1<<4);
   
    LPC_TIM1->MR0 = TimerInterval;
    LPC_TIM1->MCR = 3;				/* Interrupt and Reset on MR1 */
    NVIC_EnableIRQ(TIMER1_IRQn);
}


//////////////////////////////////////////////////////////////////////
/////////////////////////включение таймера 1//////////////////////////
//////////////////////////////////////////////////////////////////////
void enable_timer1( void )
{
    LPC_TIM1->TCR = 1;
    return;
}


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////TIMER2//////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
/////////////////////инициализация таймера 2 /////////////////////////
//////////////////////////////////////////////////////////////////////
unsigned int Init_TIM2 (void)
{
    LPC_TIM2->MR0 = 257;
    LPC_TIM2->MCR = 3;				/* Interrupt and Reset on MR0 */
    NVIC_EnableIRQ(TIMER2_IRQn);
    return 1;
}

//////////////////////////////////////////////////////////////////////
/////////////////////////включение таймера 2//////////////////////////
//////////////////////////////////////////////////////////////////////
void enable_timer2(void)
{
    LPC_TIM2->TCR = 1;
    LPC_TIM2->TCR = 0x01;
}


//////////////////////////////////////////////////////////////////////
/////////////////////////прерывание таймера 1//////////////////////////
//////////////////////////////////////////////////////////////////////
__irq void TIMER1_IRQHandler (void)//13.27 kHz(vibro*32)
{   

    ResetCS(ADC);					  	 	//prepare ADC for sampling
    SetDAC(DAC);
    Global_Time++;
    CountV255++;							// инкремент счеттчика
    CountV511++;
    CountV255 &= 0xff;						// ОБРЕЗАНИЕ СЧЕТЧИКА 
    CountV511 &= 0x1ff;
    CountV64 = CountV255 & 0x3f;
    CountV31 = CountV255 & 0x1f;			// малый счетчик
   
    D_QEI();								//чтение данных по счетчику
    cheng();		             			// выставление флагов в 32 тактном цикле.


    SetCS(ADC);					    		//start ADC sampling
    ResetDAC(DAC);
	SPI_Exchange(); 						//Чтение ADC_SPI

    LPC_TIM1->IR = 1;   
    
}

///////////////////////////////////////////////////////////////////////
/////////////////////////прерывание таймера 2//////////////////////////
///////////////////////////////////////////////////////////////////////
__irq void TIMER2_IRQHandler (void)
{   
   /// LoopOn
    LPC_TIM2->IR = 1;
	if (Gyro.UARTFlag)
		{
   		 if(Time_UART) Time_UART--;
   		}
   	//	 

    Time_vibro++;
   // VibroOut();
    Gyro.VibroOutF=1;
    Event100K ++; 
    Time1250Hz++; 
    Time500Hz++;
    Time250Hz++;
    Time100K++;
    Time5K++;
    //Time2K++;
 //   Time250Hz++;
 
        if (Time1250Hz > 79)
         {  
            Time1250Hz -= 80;
            Event1250Hz ++;
         }
        if (Time100K == 100)
         { // LoopOn
            Time100K = 0;
            Event1K ++;
             // LoopOn
         }
         
         if (Time5K > 200000)
         {  Time5K = 0;
            if(Gyro.Debag)
            {   
       		 for(int q=0; q<64; q++)
			    {	
 		      	sprintf((Time),"%i   \r\n", ModArraySin	[q]);
    	   		WriteCon(Time);
          		}
          	}
            Event5K ++;
         }
         
        if (Time500Hz > 200) 
         { // LoopOn
            Time500Hz -= 200;
            Event500Hz ++;     
         }
         
           if (Time250Hz > 6) 
         { // LoopOn
            Time250Hz -= 6;
            Event250Hz ++;     
         }
   
    //LoopOff
}